codeforces round 369div2 C Coloring Trees

来源:互联网 发布:前台数据传到msql乱码 编辑:程序博客网 时间:2024/06/05 15:05

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 1001 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples
input
3 2 20 0 01 23 45 6
output
10
input
3 2 22 1 21 32 43 5
output
-1
input
3 2 22 0 01 32 43 5
output
5
input
3 2 32 1 21 32 43 5
output
0
Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.


这是一道三维DP题

题目的大意是给定n棵树,有些树有颜色,有些没有,要求给那些没有颜色的树上色,这个人只认识m种颜色,每种颜色有花费

上完色后要看看每棵树的颜色的种类,连续的种类为一个beauty,要你在上完色的时候构成k个beauty并且花费最少。

构建dp[i][j][k]为第i棵树j个beauty选第k个颜色时的花费。

然后暴力dp,时间复杂度是O(n*k*m^2

其次inf要写的很大,不然就达不到数据。

参考高手的做法这边inf给2000000000000000ll

代码如下:

#include<cstdio>#include<cstring>#include<iostream>#include<algorithm>using namespace std;#define N 110long long int dp[N][N][N],a[N],b[N][N];#define inf 2000000000000000llint main(){    int k,i,j,n,m,p,x,q;    cin>>n>>m>>k;    for(i=1;i<=n;i++) cin>>a[i];    for(i=1;i<=n;i++)        for(j=1;j<=m;j++)        cin>>b[i][j];        for(i=0;i<=100;i++) for(j=0;j<=100;j++) for(p=0;p<=100;p++) dp[i][j][p]=inf;        dp[0][1][0]=0;    for(i=0;i<n;i++)        for(j=1;j<=k;j++)            for(p=0;p<=m;p++){                    if(dp[i][j][p]==inf) continue;                if(a[i+1]!=0){                    if(p==0||a[i+1]==p) dp[i+1][j][a[i+1]]=min(dp[i+1][j][a[i+1]],dp[i][j][p]);                    if(p!=0&&a[i+1]!=p) dp[i+1][j+1][a[i+1]]=min(dp[i+1][j+1][a[i+1]],dp[i][j][p]);                }                else if(a[i+1]==0){                    for(q=1;q<=m;q++)                if(q!=p){                  if(p!=0) dp[i+1][j+1][q]=min(dp[i+1][j+1][q],dp[i][j][p]+b[i+1][q]);                  if(p==0) dp[i+1][j][q]=min(dp[i+1][j][q],dp[i][j][p]+b[i+1][q]);                        }                if(p!=0) dp[i+1][j][p]=min(dp[i+1][j][p],dp[i][j][p]+b[i+1][p]);                  }            }    long long int res=inf;    for(i=1;i<=m;i++){        //cout<<dp[n][k][i]<<endl;        res=min(res,dp[n][k][i]);    }    if(res==inf) res=-1;    cout<<res<<endl;    return 0;}



0 0
原创粉丝点击